/* flfm.f -- translated by f2c (version 19960717).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal flsm_(s, center, hwidth, x, m, mp, maxord, g, f, sumcls)
integer *s;
doublereal *center, *hwidth, *x;
integer *m, *mp, *maxord;
doublereal *g;
real *f;
integer *sumcls;
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal ret_val;

    /* Local variables */
    static doublereal zero;
    static integer i__, l, ihalf;
    extern doublereal adphlp_();
    static integer ixchng, lxchng, imnusl;
    static doublereal intwgt, intsum, one;
    static integer mpi, mpl;
    static doublereal two;


/* ***  FUNCTION TO COMPUTE FULLY SYMMETRIC BASIC RULE SUM */

    /* Parameter adjustments */
    --mp;
    --m;
    --x;
    --hwidth;
    --center;
    --g;

    /* Function Body */
    zero = 0.;
    one = 1.;
    two = 2.;
    intwgt = one;
    i__1 = *s;
    for (i__ = 1; i__ <= i__1; ++i__) {
	mp[i__] = m[i__];
	if (m[i__] != 0) {
	    intwgt /= two;
	}
	intwgt *= hwidth[i__];
/* L10: */
    }
    *sumcls = 0;
    ret_val = zero;

/* *******  COMPUTE CENTRALLY SYMMETRIC SUM FOR PERMUTATION MP */
L20:
    intsum = zero;
    i__1 = *s;
    for (i__ = 1; i__ <= i__1; ++i__) {
	mpi = mp[i__] + 1;
	x[i__] = center[i__] + g[mpi] * hwidth[i__];
/* L30: */
    }
L40:
    ++(*sumcls);
/* mmm */
    intsum += adphlp_(f, s, &x[1]);
    i__1 = *s;
    for (i__ = 1; i__ <= i__1; ++i__) {
	mpi = mp[i__] + 1;
	if (g[mpi] != zero) {
	    hwidth[i__] = -hwidth[i__];
	}
	x[i__] = center[i__] + g[mpi] * hwidth[i__];
	if (x[i__] < center[i__]) {
	    goto L40;
	}
/* L50: */
    }
/* *******  END INTEGRATION LOOP FOR MP */

    ret_val += intwgt * intsum;
    if (*s == 1) {
	return ret_val;
    }

/* *******  FIND NEXT DISTINCT PERMUTATION OF M AND LOOP BACK */
/*          TO COMPUTE NEXT CENTRALLY SYMMETRIC SUM */
    i__1 = *s;
    for (i__ = 2; i__ <= i__1; ++i__) {
	if (mp[i__ - 1] <= mp[i__]) {
	    goto L80;
	}
	mpi = mp[i__];
	ixchng = i__ - 1;
	if (i__ == 2) {
	    goto L70;
	}
	ihalf = ixchng / 2;
	i__2 = ihalf;
	for (l = 1; l <= i__2; ++l) {
	    mpl = mp[l];
	    imnusl = i__ - l;
	    mp[l] = mp[imnusl];
	    mp[imnusl] = mpl;
	    if (mpl <= mpi) {
		--ixchng;
	    }
	    if (mp[l] > mpi) {
		lxchng = l;
	    }
/* L60: */
	}
	if (mp[ixchng] <= mpi) {
	    ixchng = lxchng;
	}
L70:
	mp[i__] = mp[ixchng];
	mp[ixchng] = mpi;
	goto L20;
L80:
	;
    }
/* *****  END LOOP FOR PERMUTATIONS OF M AND ASSOCIATED SUMS */

    return ret_val;
} /* flsm_ */

