/* symrl.f -- translated by f2c (version 19960717).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int symrl_(s, center, hwidth, f, minord, maxord, intvls, 
	intcls, numsms, weghts, fulsms, fail)
integer *s;
doublereal *center, *hwidth, *f;
integer *minord, *maxord;
doublereal *intvls;
integer *intcls, *numsms;
doublereal *weghts, *fulsms;
integer *fail;
{
    /* Initialized data */

    static doublereal g[20] = { 0.,.7745966692414833,.9604912687080202,
	    .4342437493468025,.9938319632127549,.8884592328722569,
	    .6211029467372263,.2233866864289668,.1,.2,.3,.4 };

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Local variables */
    extern doublereal flsm_();
    static integer maxs;
    static doublereal zero;
    static integer d__, i__, k[20], l, m[20];
    extern /* Subroutine */ int nxprt_();
    static integer modofm;
    static real floatl, hundrd;
    static doublereal gisqrd, intmpa, glsqrd, intmpb, intval, momnkn, momprd[
	    400]	/* was [20][20] */, moment[20];
    static integer maxrdm, sumcls;
    static doublereal momtol;
    static real fulwgt;
    static integer prtcnt;
    static doublereal one;
    extern doublereal wht_();
    static doublereal two;

/*  MULTIDIMENSIONAL FULLY SYMMETRIC RULE INTEGRATION SUBROUTINE */

/*   THIS SUBROUTINE COMPUTES A SEQUENCE OF FULLY SYMMETRIC RULE */
/*   APPROXIMATIONS TO A FULLY SYMMETRIC MULTIPLE INTEGRAL. */
/*   WRITTEN BY A. GENZ, MATHEMATICAL INSTITUTE, UNIVERSITY OF KENT, */
/*   CANTERBURY, KENT CT2 7NF, ENGLAND */

/* **************  PARAMETERS FOR SYMRL  ******************************** 
*/
/* *****INPUT PARAMETERS */
/*  S       INTEGER NUMBER OF VARIABLES, MUST EXCEED 0 BUT NOT EXCEED 20 
*/
/*  F       EXTERNALLY DECLARED USER DEFINED REAL FUNCTION INTEGRAND. */
/*          IT MUST HAVE PARAMETERS (S,X), WHERE X IS A REAL ARRAY */
/*          WITH DIMENSION S. */
/*  MINORD  INTEGER MINIMUM ORDER PARAMETER.  ON ENTRY MINORD SPECIFIES */
/*          THE CURRENT HIGHEST ORDER APPROXIMATION TO THE INTEGRAL, */
/*          AVAILABLE IN THE ARRAY INTVLS.  FOR THE FIRST CALL OF SYMRL */
/*          MINORD SHOULD BE SET TO 0.  OTHERWISE A PREVIOUS CALL IS */
/*          ASSUMED THAT COMPUTED INTVLS(1), ... , INTVLS(MINORD). */
/*          ON EXIT MINORD IS SET TO MAXORD. */
/*  MAXORD  INTEGER MAXIMUM ORDER PARAMETER, MUST BE GREATER THAN MINORD 
*/
/*          AND NOT EXCEED 20. THE SUBROUTINE COMPUTES INTVLS(MINORD+1), 
*/
/*          INTVLS(MINORD+2),..., INTVLS(MAXORD). */
/*  G       REAL ARRAY OF DIMENSION(MAXORD) OF GENERATORS. */
/*          ALL GENERATORS MUST BE DISTINCT AND NONNEGATIVE. */
/*  NUMSMS  INTEGER LENGTH OF ARRAY FULSMS, MUST BE AT LEAST THE SUM OF */
/*          THE NUMBER OF DISTINCT PARTITIONS OF LENGTH AT MOST S */
/*          OF THE INTEGERS 0,1,...,MAXORD-1.  AN UPPER BOUND FOR NUMSMS 
*/
/*          WHEN S+MAXORD IS LESS THAN 19 IS 200 */
/* ******OUTPUT PARAMETERS */
/*  INTVLS  REAL ARRAY OF DIMENSION(MAXORD).  UPON SUCCESSFUL EXIT */
/*          INTVLS(1), INTVLS(2),..., INTVLS(MAXORD) ARE APPROXIMATIONS */
/*          TO THE INTEGRAL.  INTVLS(D+1) WILL BE AN APPROXIMATION OF */
/*          POLYNOMIAL DEGREE 2D+1. */
/*  INTCLS  INTEGER TOTAL NUMBER OF F VALUES NEEDED FOR INTVLS(MAXORD) */
/*  WEGHTS  REAL WORKING STORAGE ARRAY WITH DIMENSION (NUMSMS). ON EXIT */
/*          WEGHTS(J) CONTAINS THE WEIGHT FOR FULSMS(J). */
/*  FULSMS  REAL WORKING STORAGE ARRAY WITH DIMENSION (NUMSMS). ON EXIT */
/*          FULSMS(J) CONTAINS THE FULLY SYMMETRIC BASIC RULE SUM */
/*          INDEXED BY THE JTH S-PARTITION OF THE INTEGERS */
/*          0,1,...,MAXORD-1. */
/*  FAIL    INTEGER FAILURE OUTPUT PARAMETER */
/*          FAIL=0 FOR SUCCESSFUL TERMINATION OF THE SUBROUTINE */
/*          FAIL=1 WHEN NUMSMS IS TOO SMALL FOR THE SUBROUTINE TO */
/*                  CONTINUE.  IN THIS CASE WEGHTS(1), WEGHTS(2), ..., */
/*                  WEGHTS(NUMSMS), FULSMS(1), FULSMS(2), ..., */
/*                  FULSMS(NUMSMS) AND INTVLS(1), INTVLS(2),..., */
/*                  INTVLS(J) ARE RETURNED, WHERE J IS MAXIMUM VALUE OF */
/*                  MAXORD COMPATIBLE WITH THE GIVEN VALUE OF NUMSMS. */
/*          FAIL=2 WHEN PARAMETERS S,MINORD, MAXORD OR G ARE OUT OF */
/*                  RANGE */
/* ***********************************************************************
 */
/* mmm      EXTERNAL F */
/* tsl	real F */
/* ***  FOR DOUBLE PRECISION CHANGE REAL TO DOUBLE PRECISION */
/*      IN THE NEXT STATEMENT */
/*       PATTERSON GENERATORS */
    /* Parameter adjustments */
    --hwidth;
    --center;
    --intvls;
    --fulsms;
    --weghts;

    /* Function Body */

/* ***  PARAMETER CHECKING AND INITIALISATION */
    *fail = 2;
    maxrdm = 20;
    maxs = 20;
    if (*s > maxs || *s < 1) {
	return 0;
    }
    if (*minord < 0 || *minord >= *maxord) {
	return 0;
    }
    if (*maxord > maxrdm) {
	return 0;
    }
    zero = 0.;
    one = 1.;
    two = 2.;
    momtol = one;
L10:
    momtol /= two;
    if (momtol + one > one) {
	goto L10;
    }
    hundrd = (float)100.;
    momtol = hundrd * two * momtol;
    d__ = *minord;
    if (d__ == 0) {
	*intcls = 0;
    }
/* ***  CALCULATE MOMENTS AND MODIFIED MOMENTS */
    i__1 = *maxord;
    for (l = 1; l <= i__1; ++l) {
	floatl = (real) (l + l - 1);
	moment[l - 1] = two / floatl;
/* L20: */
    }
    if (*maxord == 1) {
	goto L50;
    }
    i__1 = *maxord;
    for (l = 2; l <= i__1; ++l) {
	intmpa = moment[l - 2];
/* Computing 2nd power */
	d__1 = g[l - 2];
	glsqrd = d__1 * d__1;
	i__2 = *maxord;
	for (i__ = l; i__ <= i__2; ++i__) {
	    intmpb = moment[i__ - 1];
	    moment[i__ - 1] -= glsqrd * intmpa;
	    intmpa = intmpb;
/* L30: */
	}
/* Computing 2nd power */
	d__1 = moment[l - 1];
/* Computing 2nd power */
	d__2 = momtol * moment[0];
	if (d__1 * d__1 < d__2 * d__2) {
	    moment[l - 1] = zero;
	}
/* L40: */
    }
L50:
    i__1 = *maxord;
    for (l = 1; l <= i__1; ++l) {
	if (g[l - 1] < zero) {
	    return 0;
	}
	momnkn = one;
	momprd[l - 1] = moment[0];
	if (*maxord == 1) {
	    goto L70;
	}
/* Computing 2nd power */
	d__1 = g[l - 1];
	glsqrd = d__1 * d__1;
	i__2 = *maxord;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    if (i__ <= l) {
/* Computing 2nd power */
		d__1 = g[i__ - 2];
		gisqrd = d__1 * d__1;
	    }
	    if (i__ > l) {
/* Computing 2nd power */
		d__1 = g[i__ - 1];
		gisqrd = d__1 * d__1;
	    }
	    if (glsqrd == gisqrd) {
		return 0;
	    }
	    momnkn /= glsqrd - gisqrd;
	    momprd[l + i__ * 20 - 21] = momnkn * moment[i__ - 1];
/* L60: */
	}
L70:
	;
    }
    *fail = 1;

/* ***  BEGIN LOOP FOR EACH D */
/*      FOR EACH D FIND ALL DISTINCT PARTITIONS M WITH MOD(M))=D */

L80:
    prtcnt = 0;
    intval = zero;
    modofm = 0;
    nxprt_(&prtcnt, s, m);
L90:
    if (prtcnt > *numsms) {
	return 0;
    }

/* ***  CALCULATE WEIGHT FOR PARTITION M AND FULLY SYMMETRIC SUMS */
/* ***     WHEN NECESSARY */

    if (d__ == modofm) {
	weghts[prtcnt] = zero;
    }
    if (d__ == modofm) {
	fulsms[prtcnt] = zero;
    }
    fulwgt = wht_(s, moment, m, k, &modofm, &d__, &maxrdm, momprd);
    sumcls = 0;
    if (weghts[prtcnt] == zero && fulwgt != zero) {
	fulsms[prtcnt] = flsm_(s, &center[1], &hwidth[1], moment, m, k, 
		maxord, g, f, &sumcls);
    }
    *intcls += sumcls;
    intval += fulwgt * fulsms[prtcnt];
    weghts[prtcnt] += fulwgt;
    nxprt_(&prtcnt, s, m);
    if (m[0] > modofm) {
	++modofm;
    }
    if (modofm <= d__) {
	goto L90;
    }

/* ***  END LOOP FOR EACH D */
    if (d__ > 0) {
	intval = intvls[d__] + intval;
    }
    intvls[d__ + 1] = intval;
    ++d__;
    if (d__ < *maxord) {
	goto L80;
    }

/* ***  SET FAILURE PARAMETER AND RETURN */
    *fail = 0;
    *minord = *maxord;
    return 0;
} /* symrl_ */

